



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>asp.net core系列 53 IdentityServer4 (IS4)介绍</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">asp.net core系列 53 IdentityServer4 (IS4)介绍</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 02:51:36 </span>
						</div>
										<div class="post-content">
											
		<h3>一.概述</h3>
<p>　　在物理层之间相互通信必须保护资源，需要实现身份验证和授权，通常针对同一个用户存储。对于资源安全设计包括二个部分，一个是认证，一个是API访问。</p>
<p>　</p>
<p>　　<strong>1 认证</strong></p>
<p>　　　　认证是指：应用程序需要知道当前用户的身份时，需要进行身份验证，确定用户是否有效。最常见的身份验证协议是SAML2p，WS-Federation、OpenID Connect。SAML2p是最受欢迎和最广泛部署的。OpenID Connect是三者中的最新产品,被认为有最大潜力。。</p>
<p>　　<strong>2&nbsp;API访问</strong></p>
<p>　　　　对API访问是：用户对资源的访问，以api的形式来访问资源，涉及到资源授权。</p>
<p>　　<strong>3 OAuth2 介绍</strong></p>
<p>　　　　OAuth2是一种协议，全称(Open Authorization)，是为用户资源的授权提供了一个安全的、开放而又简易的标准。互联网很多服务如Open API都提供了OAUTH认证服务。为桌面程序、手机端或web应用提供了一种简单的，标准的方式去访问需要用户授权的API服务。OAuth2协议特定：</p>
<p>(1)简单：不管是OAUTH服务提供者还是应用开发者，都很易于理解与使用。</p>
<p>(2)安全：没有涉及到用户密钥等信息，更安全更灵活。</p>
<p>(3)开放：任何服务提供商都可以实现OAUTH，任何软件开发商都可以使用OAUTH。</p>
<p>　　<strong>4 OIDC介绍</strong></p>
<p>　　　　OIDC是指OpenID Connect，是基于OAuth 2.0规范的可互操作的身份验证协议。是用 API 进行身份交互的框架。它使用简单的REST / JSON消息流来实现。OIDC实现了用户验证跨越物理层，无需管理密码文件(密钥)。</p>
<p>　　　　OpenID是Authentication，即认证。对用户的身份进行认证，判断其身份是否有效。</p>
<p>　　　　OAuth是Authorization，即授权。 对用户允许访问哪些资源的授权。 授权要在认证之后进行，只有确定用户身份才能授权。</p>
<p>　　　　OpenID Connect是&ldquo;认证&rdquo;和&ldquo;授权&rdquo;的结合。是对OAuth 2.0之上的扩展。这样对于两个基本的安全问题，即身份验证和API访问，被合并为一个协议，通常只需一次往返安全令牌服务。</p>
<p>　　<strong>5 IdentityServer4 介绍</strong></p>
<p>　　　　IdentityServer4 是适用于ASP.NET Core，集成了OpenID Connect和OAuth 2.0的框架。在现实开发中，项目涉及到多种物理层架构，它们是多进程的方式部署到不同的服务器上。比如Web、移动、桌面、服务等物理层架构。也有可能是第三方的程序。 这些物理层之间的通信需要涉及到授权和身份认证。最常见的互动包括：</p>
<p>　　　　(1) 浏览器与Web应用程序通信。</p>
<p>　　　　(2) Web应用程序与Web API进行通信（可能都是自己的，也有可能是第三方提供）。</p>
<p>　　　　(3) 服务器的应用程序与Web API通信(比如windows服务与Web API)。</p>
<p>　　　　(4) Web API与Web API进行通信（可能都是自己的，也有可能是第三方提供）。</p>
<p>　　　　在没有使用安全令牌服务时，多物理层之间通信，看起来像下面这样：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/151560/201904/151560-20190410135444739-1333748023.png" /></p>
<p>　　　　加了IdentityServer4重构应用程序后，使用了安全令牌服务，产生的体系结构和协议如下所示：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/151560/201904/151560-20190410135528140-1811621297.png" /></p>
<p>　　<strong> 6 IdentityServer功能包括：</strong></p>
<p>　　　　(1)保护你的资源(资源可以理解包括权限，比如是否有增、删、改、查的权限)</p>
<p>　　　　(2)使用本地帐户存储或外部身份提供程序对用户进行身份验证</p>
<p>　　　　(3)提供会话管理和单点登录</p>
<p>　　　　(4)管理和验证客户端</p>
<p>　　　　(5)向客户发放身份和访问令牌</p>
<p>　　　　(5)验证令牌</p>
<p>　　</p>
<p>　　<strong>7 名词术语</strong></p>
<p>　　　　用户是指：通过注册成功后， 登录来访问资源的人。比如：会员，系统管理员等。</p>
<p>　　　　客户端是指：向IdentityServer请求令牌的程序，用于验证用户（请求身份令牌）或访问资源（请求访问令牌）。如Web应用程序，本机移动或桌面应用程序，SPA，服务器进程等。</p>
<p>　　　　资源：使用IdentityServer保护资源，比如用户的身份数据或API。身份数据是关于用户的信息也称Claim声明, 例如姓名或电子邮件地址。API表示客户端要调用的功能如Web API。</p>
<p>　　　　身份令牌：是指身份验证过程，确实用户是否有效。即Authentication认证。</p>
<p>　　　　访问令牌：是指允许访问API资源。即Authorization授权。</p>
<p>　　<strong>8&nbsp;nuget包安装</strong></p>
<p>　　　　安装版本网址：https://www.nuget.org/packages/IdentityServer4/3.0.0-preview3.4</p>
<p>　　　　安装：Install-Package IdentityServer4</p>
<p>　　<strong>9&nbsp;关于IdentityServer4的一些开源示例</strong></p>
<p>　　　　<a href="https://identityserver4.readthedocs.io/en/latest/intro/packaging.html" rel="external nofollow noreferrer">https://identityserver4.readthedocs.io/en/latest/intro/packaging.html</a></p>
<p>　　　　下面是关于IdentityServer的源码和示例，其中IdentityServer4.Samples中有大量示例，学习从这里开始。</p>
<p>　　　　<a href="https://github.com/IdentityServer/" rel="external nofollow noreferrer">https://github.com/IdentityServer/</a></p>
<p>　　<strong>10&nbsp; 学习IdentityServer步骤</strong></p>
<p>　　　　(1) 将IdentityServer添加到ASP.NET Core应用程序</p>
<p>　　　　(2) 配置IdentityServer</p>
<p>　　　　(3) 为各种客户发放令牌</p>
<p>　　　　(4) 保护Web应用程序和API</p>
<p>　　　　(5) 添加对基于EntityFramework的配置的支持</p>
<p>　　　　(6) 添加对ASP.NET身份的支持</p>
<p>　　　　(7) 添加AdminUI社区版以管理用户和配置</p>
<p>　　</p>
<p>　　参考文献</p>
<p>　　　　　<a href="https://identityserver4.readthedocs.io/en/latest/intro/big_picture.html" rel="external nofollow noreferrer">IdentityServer4官方文档介绍</a>　</p>																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8o1nlxq.html">回忆那些我们曾今铭记过的&period;NET重点知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kjme79.html">C&num;图片色彩的纠正-上</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kdek59.html">053医疗项目-模块五：权限设置-将用户操作权限写入Session</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwp7rl8.html">CentOS上使用sysstat做系统监控测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96v6p48.html">java日期和字符串的相互转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydmp5gq.html">jsp 2种include标签的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvxwnyq.html">WildFly8&period;1&lpar;JBoss&rpar;&plus;mod&lowbar;cluster&lpar;Apache&rpar;群集配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yj50g8.html">CharSequence的getText&lpar;&rpar;与String的getString&lpar;&rpar;&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jlg3v8.html">C&num;在PDF中如何以不同颜色高亮文本</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2jd2z9.html">禁用cookie后的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1dndl9.html">document&period;getElementById&lpar;&OpenCurlyDoubleQuote;id&rdquo;&rpar;与&dollar;&lpar;&amp;quot&semi;&num;id&amp;quot&semi;&rpar;的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4gkmx9.html">百度地图API 自定义坐标点及图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g4w6eq.html">如何自学web安全（详细路径）</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1ld269.html">java时区转化相关工具方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2onme8.html">使用tagName定位报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy2yjeg9.html">qt 创建资源文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q77o5mjq.html">Jmeter对HTTP请求压力测试、并发测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pmmped9.html">判断两个字符串是否相等【JAVA】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e05lzkq.html">Oracle Extended Tracing</a>
		</li>
						<li><a href="https://www.batexi.com/a/q77nkveq.html">虚拟机安装Ubuntu过程记录</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gevywl8.html">php获取指定目录下的所有文件列表</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zyynj9.html">再次实践 MySQL chart - 每天5分钟玩转 Docker 容器技术（166）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zon07nq.html">PAT1052&colon;Linked List Sorting</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1jmpmq.html">left join 后的条件 位置不同，查询的结果不同</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jz4kzg8.html">SqlSugar 盲点</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zy4dg9.html">Centos7搭建hadoop完全分布式</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me7gk0q.html">Java开源生鲜电商平台-账单模块的设计与架构&lpar;源码可下载）</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m37ej8.html">DUBBO报错分析&mdash;1（连接zookeeper成功，调用方法无反应，不报错）</a>
			</li>
						<li><a href="https://www.batexi.com/a/950er1e8.html">你不知道的JavaScript--Item12 undefined 与 null</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljrm219.html">一句python代码搭建FTP服务</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
